import 'package:backend_dart/domain/interface/error.dart';
import 'package:fpdart/fpdart.dart';

abstract class UserDataSource<T> {
  TaskEither<IError, T> create(T user);

  TaskEither<IError, T> findByEmail(String email);

  TaskEither<IError, T> findById(String id);

  TaskEither<IError, T> update(T user);

  TaskEither<IError, void> delete(String id);

  TaskEither<IError, List<T>> findAll();

  TaskEither<IError,String> generateId();
}
