import 'package:backend_dart/domain/interface/database.dart';
import 'package:backend_dart/infrastructure/persistence/db/client.dart';
import 'package:backend_dart/infrastructure/persistence/prisma_user_data_source.dart';

class PrismaDatabase implements IDatabase {
  final prisma = PrismaClient();
  late final PrismaUserDataSource _users;
  PrismaDatabase() {
    _users = PrismaUserDataSource(prisma);
    print('Database initialized');
  }

  @override
  get users => _users;
  @override
  Future<void> close() {
    return Future.value();
  }
}
